
const TOKEN = 'TOKEN'

interface Params {
  params?: any,
  url: string,
  method: Request.Methods
  responseType?: '',
  baseURL?: string
}

const BASEURL = 'http://local.luojigou.vip:8888'

export const request = async <T>(
  params: Params
) => {

  let data = params.params || {};
  let url = (params.baseURL ? params.baseURL: BASEURL) + params.url;
  let method = params.method
  let responseType = params.responseType

  let token = uni.getStorageSync(TOKEN);


  const response = await new Promise(resolve => {
     uni.request({
      url: url,
      method: method,
      data: data,
      header: {
        'content-type': 'application/json',
        token
      },
      responseType,
      success: res => resolve(res.data)
    })
  })

  return response as API.Response<T>
}


