import { LocalStorageStateEnum } from "@/enum/localStore"
import { ConstantStoreEnum } from "@/enum/store"
import { defineStore } from "pinia"
import { useLocalStorageState } from 'vue-hooks-plus'
import { reactive  } from 'vue'


export const usePracticeStore = defineStore(ConstantStoreEnum.PRACTICE, () => {

  let appPracticeStore = reactive<Record<string, string[]>>({})

  const [ practice, setPractice ] = useLocalStorageState<Record<string, string[]>>(LocalStorageStateEnum.PRACTICE)

  appPracticeStore = practice.value!

  const get = (collectionId: string, cardIds: string[]) => {
    
    const olds = practice.value![collectionId] || []

    const diffIds = cardIds.filter( cardId => !olds.includes(cardId))

    if (diffIds.length === 0 || diffIds.length == cardIds.length) {
      setPractice({
        ...practice.value,
        [collectionId]: []
      })
      return cardIds
    } else {
      return diffIds
    }
  }

  const set = (collectionId: string, cardId: string) => {
    practice.value![collectionId].push(cardId)
  }

  // get (stage) 获取collectionIds 的请求也在这个里边来请求

  // submit stage cardId

  // current stage

  // getNextCardId 

  // if all sumit 清空题卡

  return {
    get,
    set
  }

})


